proc SelOpt_AddOpt {wcan w wstatus}  {
	global SelOpt

	if ![info exists SelOpt($w,num) ] {
		ShowStatus "No File(s) Selected !" $wstatus
		return
	}
	SelOpt_CleanWinOpt $w
	
	set num_old $SelOpt($w,num)
	incr SelOpt($w,num)

	#Shift all existing options to te right
	for {set i $num_old} {$i >= 1} {incr i -1} {
		set ip1 [expr $i + 1]
		set SelOpt($w,$ip1,val) $SelOpt($w,$i,val) 
		set SelOpt($w,$ip1) $SelOpt($w,$i)
	}

	#Add a New First option (default is an unchecked option)
	set SelOpt($w,1,val) {<none>}
	set SelOpt($w,1) 0

	SelOpt_UpdateOpt $wcan $w $wstatus
}
proc SelOpt_CleanWinOpt {w}  {
	global SelOpt
	if [ info exists SelOpt($w,num) ] {
		for {set i 1} {$i <= $SelOpt($w,num)} {incr i} {
			catch "destroy $w.$i"
		}
	}
}
proc SelOpt_UndoKillOpt {wcan w wstatus}  {
	global SelOpt
	if ![info exists SelOpt($w,num) ] {
		ShowStatus "No File(s) Selected !" $wstatus
		return
	}

	set last [ expr $SelOpt($w,num) + 1 ]
	if { [info exists SelOpt($w,$last)] && [info exists SelOpt($w,$last,val)] } {
		SelOpt_CleanWinOpt $w
		incr SelOpt($w,num)
		SelOpt_UpdateOpt $wcan $w $wstatus
 	}

}
proc SelOpt_KillOpt { wcan w ikill wstatus}  {
# Move the "killed" value at the end of arrays
	global SelOpt

	SelOpt_CleanWinOpt $w


	# Save the values to be killed (why not ...)
	set ind_ikill $SelOpt($w,$ikill)
	set val_ikill $SelOpt($w,$ikill,val)

	# Re-num all the good one (shift to the left, starting at "ikill")
	set igeb $ikill
	set iend [expr $SelOpt($w,num) - 1]
	for {set i $igeb} {$i <= $iend} {incr i} {
		set ip1 [expr $i + 1 ]
		set SelOpt($w,$i) $SelOpt($w,$ip1)
		set SelOpt($w,$i,val) $SelOpt($w,$ip1,val)
	}

	# Put the values to be killed at the end (why not ...)
	set ikill $SelOpt($w,num)
	set SelOpt($w,$ikill) $ind_ikill
	set SelOpt($w,$ikill,val) $val_ikill

	# get the new number of active opt.
	incr SelOpt($w,num) -1

	SelOpt_UpdateOpt $wcan $w $wstatus
}

proc SelOpt_UpdateOpt {wcan wsel wstatus}  {

	global SelOpt

	# Create and pack the widgets
	for {set i 1} {$i <= $SelOpt($wsel,num)} {incr i} {
		pack [frame $wsel.$i] -side top -expand y -fill both
		entry 		$wsel.$i.prompt -width 20 -textvariable SelOpt($wsel,$i,val)
		checkbutton	$wsel.$i.check -variable SelOpt($wsel,$i) -relief flat
		button 		$wsel.$i.kill -text Kill \
				-command [list SelOpt_KillOpt $wcan $wsel $i $wstatus] -cursor {pirate}
		pack $wsel.$i.prompt $wsel.$i.check $wsel.$i.kill -side left -anchor w

		bind $wsel.$i.prompt <Enter> [list show-status "Modify/Enter Option" $wstatus]
		bind $wsel.$i.check  <Enter> [list ShowStatus "Set Option On/off" $wstatus]
		bind $wsel.$i.kill   <Enter> [list ShowStatus "Kill the Option !" $wstatus]
		bind $wsel.$i        <Leave> [list ShowStatus "Ready..." $wstatus]
	}

	set child0 [lindex [pack slaves $wsel] 0]

	# Update the ScrollBar of the Canvas ! :
	# - Wait for the window to become visible and then
	# - set up the scroll region and increment based on
	#   the size of the frame and the subframes

	if ![winfo exists $child0] {return}
	tkwait visibility $child0

 	set incr [winfo height $child0]
	set width [winfo width $wsel]
	set height [winfo height $wsel]
	$wcan config -scrollregion "0 0 $width $height"
	$wcan config -yscrollincrement $incr
	if {$height > 4 * $incr} {
		set height [expr 4 * $incr]
	}
	$wcan config -width $width -height $height
}
proc SelOpt_Unset {w} {
	global SelOpt
	if [info exists SelOpt($w,num) ] {
		for {set i 1} {$i <= $SelOpt($w,num)} {incr i} {
			catch {unset SelOpt($w,$i)}
			catch {unset SelOpt($w,$i,val)}
		}
		unset SelOpt($w,num)
	}
}

proc SelOpt_ListToArray {list w} {
#save Option@Flag associated to ref into array global array SelOpt(ref,...)
	global SelOpt
	SelOpt_Unset $w
	set i 0
	foreach valflag $list {
		set opt  [GetVal_ValFlag $valflag]
		set flag [GetFlag_ValFlag $valflag]

		incr i
		set SelOpt($w,$i)     $flag
		set SelOpt($w,$i,val) $opt
	}
	set SelOpt($w,num) $i
}
